package kr.pe.kkaok.mycount;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kr.pe.kkaok.mycount.command.*;
import kr.pe.kkaok.util.ParamUtil;

/**
 * servlet controller. 
 *  ī ٰδ  .<br> http://localhost/kkaokiCount/servlet/KCount <br>
 * @author kkaok
 * @version  ī v2.4<br>
 * Copyright kkaok, All Rights Reserved.
 */
public class KCount extends HttpServlet
{
    private static final String ERRORPAGE = "/error.jsp";

    public void service(HttpServletRequest req, HttpServletResponse res) 
    {
        String sta = ParamUtil.getReqParameter(req.getParameter("sta"),"all");
        Command c = null;
        try{
            if (sta.equals("all")){
                c = new CountAllCommandImpl(req,res);
                c.exec();
            }else if (sta.equals("year")) {
                c = new CountYearCommandImpl(req,res); 
                c.exec();
            }else if (sta.equals("month")) {
                c = new CountMonthCommandImpl(req,res);
                c.exec();
            }else if (sta.equals("day")) {
                c = new CountDayCommandImpl(req,res); 
                c.exec();
            }else if (sta.equals("dayOfweek")) {
                c = new CountDayOfWeekCommandImpl(req,res);
                c.exec();
            }else if (sta.equals("ipNagent")) {
                c = new CountIpNAgentCommandImpl(req,res); 
                c.exec();
            }
        }catch(Exception e){
    		req.setAttribute("message", e.getMessage());
    		req.setAttribute("errPage", "KCount.java");
            try{
                req.getRequestDispatcher(ERRORPAGE).forward(req, res);
            }catch(Exception err){}
        }
    }
}