package kr.pe.kkaok.mycount.command;

import java.util.Calendar;
import java.util.ResourceBundle;
import java.io.PrintWriter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kr.pe.kkaok.mycount.util.CountHtmlPrint;
import kr.pe.kkaok.mycount.util.CountHtmlPrintImpl;

/**
 * abstract class Command<br>
 * ӹ޴ Ŭ exec() ݵ ؾ Ѵ.
 * @author kkaok
 * @version  ī v2.4<br>
 * Copyright kkaok, All Rights Reserved.
 */
public abstract class Command 
{ 
    protected HttpServletRequest req;
    protected HttpServletResponse res;
    protected int SINCE_YEAR;
    protected int SINCE_MONTH;
    protected int SINCE_DATE;
    protected String SINCE_DAY;
    protected int NOW_YEAR;
    protected int NOW_MONTH;
    protected int NOW_DATE;
    protected Calendar now;
    protected PrintWriter out;
    protected CountHtmlPrint cPrint;
    protected String contextRoot;
    
    public Command(HttpServletRequest req, HttpServletResponse res) throws Exception 
    {
        this.req = req;
        this.res = res;

        ResourceBundle bundle = ResourceBundle.getBundle("Res_Infomation");
        SINCE_YEAR  = Integer.parseInt(bundle.getString("SINCE_YEAR").toString());
        SINCE_MONTH = Integer.parseInt(bundle.getString("SINCE_MONTH").toString());
        SINCE_DATE  = Integer.parseInt(bundle.getString("SINCE_DATE").toString());
        SINCE_DAY   = (String)bundle.getString("SINCE_DAY");

        now = Calendar.getInstance();
        NOW_YEAR    = now.get(Calendar.YEAR);
        NOW_MONTH   = now.get(Calendar.MONTH) + 1;
        NOW_DATE    = now.get(Calendar.DATE);

        res.setContentType("text/html;charset=MS949");
        req.setCharacterEncoding("MS949");
        out = res.getWriter();
        contextRoot = req.getContextPath();
        cPrint = new CountHtmlPrintImpl();
    }
    public abstract void exec() throws Exception;
}