/*
 * Author(s) kkaok
 * Date: 2003.03.14
 * Copyright kkaok,  All Rights Reserved.
 */
package kr.pe.kkaok.mycount.command;

import java.util.Calendar;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kr.pe.kkaok.mycount.util.DateDiff;
import kr.pe.kkaok.mycount.util.DateDiffImpl;
import kr.pe.kkaok.mycount.dao.KMyCountDAOFactory;
import kr.pe.kkaok.mycount.dao.KMyCountDAO;

public class CountAllCommandImpl extends Command
{
    public CountAllCommandImpl(HttpServletRequest req, HttpServletResponse res) throws Exception 
    {
        super(req, res);
    }

    public void exec() throws Exception
    {
        int makeToday =(NOW_YEAR*10000)+(NOW_MONTH*100)+NOW_DATE;
        Calendar pd = Calendar.getInstance();
        pd.set(NOW_YEAR,NOW_MONTH-1,NOW_DATE-1);
        int makePrevDay = (pd.get(Calendar.YEAR)*10000)+((pd.get(Calendar.MONTH)+1)*100)+pd.get(Calendar.DATE);
        
        DateDiff ddf  = new DateDiffImpl();
        int daydiff = ddf.dateDiff(SINCE_YEAR,SINCE_MONTH,SINCE_DATE,NOW_YEAR,NOW_MONTH,NOW_DATE)+1;

        KMyCountDAO dao = KMyCountDAOFactory.getDAO(); 

        int totalSum = dao.getTotal();
        int today = dao.getToday(makeToday);
        int prevDay = dao.getPrevDay(makeToday,makePrevDay);

        cPrint.printHeader(out);
        cPrint.printMenu(out,contextRoot);

        out.println("  <tr>");
        out.println("    <td colspan=2 align=center>");
        out.println("   <table width=480 cellpadding=0 cellspacing=0 border=0>");
        out.println("    <TR><TD><B>Total statistics</b></TD></TR>");
        out.println("   </TABLE>");
        out.println("   <table cellspacing=0 cellpadding=3>");
        out.println("      <TR height=10><TD colspan=2></TD></TR>");
        out.println("      <tr height=20>");
        out.println("        <td width=200 align=right><b>Total : </b></td>");
        out.println("        <td width=200>"+totalSum+" hits</td>");
        out.println("      </TR>");
        out.println("      <TR height=10><TD colspan=2></TD></TR>");
        out.println("      <tr height=20>");
        out.println("        <td width=200 align=right><b>Today : </b></td>");
        out.println("        <td width=200>"+today+" hits</td>");
        out.println("        </TR>");
        out.println("      <tr height=20>");
        out.println("        <td width=200 align=right><b>Yesterday : </b></td>");
        out.println("        <td width=200>"+prevDay+" hits</td>");
        out.println("      </TR>");
        out.println("      <tr height=20>");
        out.println("        <td width=200 align=right><b>Avg hit (per day) : </b></td>");
        out.println("        <td width=200>"+(int)(totalSum/daydiff)+" hits</td>");
        out.println("      </TR>");
        out.println("      <TR height=10><TD colspan=2></TD></TR>");
        out.println("      <tr height=20>");
        out.println("        <td width=200 align=right><b>Since : </b></td>");
        out.println("        <td width=200>"+SINCE_YEAR+"-"+SINCE_MONTH+"-"+SINCE_DATE+" "+SINCE_DAY+"</td>");
        out.println("      </TR>");
        out.println("      <tr height=20>");
        out.println("        <td width=200 align=right><b>How long.... : </b></td>");
        out.println("        <td width=200>"+daydiff+" Days</td>");
        out.println("      </TR>");

        cPrint.printBottom(out,contextRoot);
    }
}