package kr.pe.kkaok.mycount.command;

import java.util.List;
import java.io.PrintWriter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kr.pe.kkaok.mycount.dao.DataItem;
import kr.pe.kkaok.mycount.dao.PlotData;
import kr.pe.kkaok.mycount.dao.KMyCountDAOFactory;
import kr.pe.kkaok.mycount.dao.KMyCountDAO;

/**
 * @author kkaok
 * @version  ī v2.4<br>
 * Copyright kkaok, All Rights Reserved.
 */
public class CountDayOfWeekCommandImpl extends Command
{
    public CountDayOfWeekCommandImpl(HttpServletRequest req, HttpServletResponse res) throws Exception 
    {
        super(req, res);
    }

    public void exec() throws Exception
    {
        KMyCountDAO dao = KMyCountDAOFactory.getDAO(); 
        PlotData data = dao.getWeeklyCnt();
        cPrint.printHeader(out);
        cPrint.printMenu(out,contextRoot);

        out.println("<tr><td colspan=2 align=center>");
        out.println("    <table width=480 cellspacing=0 cellpadding=0 border=0>");
        out.println("        <TR><TD><B>Day of Week statistics</b></TD></TR>");
        out.println("    </TABLE>");
        out.println("    <table cellspacing=0 cellpadding=3 border=0>");
        out.println("        <TR height=10><TD colspan=2></TD></TR>");
        out.println("        <tr height=20>");
        out.println("            <td width=200 align=right><b>Total : </b></td>");
        out.println("            <td width=200>"+data.total()+" hits </td>");
        out.println("        </TR>");
        out.println("        <tr height=20 >");
        out.println("            <td align=right width=200><b>Max [</b> "+data.maxLabelStr()+" <b>] : </b></td>");
        out.println("            <td width=200>"+data.maxValue()+" hits ["+(int)((float)((float)data.maxValue()/(float)data.total())*100)+"%]</td>");
        out.println("        </TR>");
        out.println("        <tr height=20 >");
        out.println("            <td align=right width=200><b>Avg : </b></td>");
        out.println("            <td width=200>"+data.avgValue()+" hits</td>");
        out.println("        </TR>");
        out.println("        <TR height=10><TD colspan=2></td></tr>");
        out.println("    </table>");
        out.println("    <table width=100% cellspacing=0 cellpadding=1>");
        out.println("        <tr height=20><td colspan=2><b>Day of Week graph</b></td>");
        out.println("        <tr height=10><td colspan=2></td></TR>");
        out.println("        <TR bgcolor=#dddddd height=1><TD colspan=2></TD></TR>");
        out.println("        <TR height=10><TD colspan=2></TD></TR>");
        DataItem items = null;
        List dataList = (List)data.getDataItems();
        for (int k=0;k<dataList.size();k++){
            items = (DataItem)dataList.get(k);
            out.println("<TR><TD width='17%' align=center>&nbsp;"+items.getLabel()+"</TD>");
            out.println("<TD><img src='"+contextRoot+"/kcount/images/graph.gif' height=10 ");
            out.println("width="+(int)((float)items.getValue()/(float)data.maxValue()*65)+"%");
            out.println(" ><span style='font-size:7pt;'>&nbsp;( "+(int)((float)items.getValue()/(float)data.total()*100)+"% <b>");
            out.println(items.getValue()+"</b> hits "); 
            if(items.getValue()==data.maxValue()){
                out.println("<font color=red>max</font>)</span></TD></TR>"); 
            }else{
                out.println(")</span></TD></TR>"); 
            }
        }
        cPrint.printBottom(out,contextRoot);
    }
}