package kr.pe.kkaok.mycount.command;

import java.io.PrintWriter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kr.pe.kkaok.mycount.command.sub.*;
import kr.pe.kkaok.util.ParamUtil;

/**
 * @author kkaok
 * @version  ī v2.4<br>
 * Copyright kkaok, All Rights Reserved.
 */
public class CountIpNAgentCommandImpl extends Command
{
    public CountIpNAgentCommandImpl(HttpServletRequest req, HttpServletResponse res) throws Exception 
    {
        super(req, res);
    }

    public void exec() throws Exception
    {
        String cmd= ParamUtil.getReqParameter(req.getParameter("cmd"),"agent");
        int thisYear  = ParamUtil.getIntParameter(req.getParameter("thisYear"),NOW_YEAR);
        int thisMonth = ParamUtil.getIntParameter(req.getParameter("thisMonth"),NOW_MONTH);
        int thisDate  = ParamUtil.getIntParameter(req.getParameter("thisDate"),NOW_DATE);
        int gotoPage  = ParamUtil.getIntParameter(req.getParameter("gotoPage"),1);
        
        int sDate = thisYear*10000+thisMonth*100+thisDate;
        int eDate = sDate;

        cPrint.printHeader(out);
        cPrint.printMenu(out,contextRoot);
        printMain(out,thisYear,thisMonth,thisDate);
        SubCommand c = null;
        if (cmd.equals("agent")){
            c = new IpnAgentDataImpl(thisYear,thisMonth,thisDate,gotoPage,out,contextRoot);
            c.exec();
        }else if (cmd.equals("ip")){
            c = new IPStatisticsImpl(sDate,eDate,out,contextRoot); 
            c.exec();
        }else if (cmd.equals("ref")){
            c = new REFStatisticsImpl(sDate,eDate,out,contextRoot);
            c.exec();
        }else if (cmd.equals("brow")){
            c = new BROWStatisticsImpl(sDate,eDate,out,contextRoot);
            c.exec();
        }else if (cmd.equals("os")){
            c = new OSStatisticsImpl(sDate,eDate,out,contextRoot); 
            c.exec();
        }
        cPrint.printBottom(out,contextRoot);
    }
        
 
    private void printMain(PrintWriter out,int thisYear,int thisMonth,int thisDate) throws Exception
    {    
        out.println("<script language=javascript>");
        out.println("    <!--");
        out.println("    window.onresize = new Function ('window.resizeTo(530,530);');");
        out.println("    function sendit(){");
        out.println("        var thisYear = document.myform.thisYear.value; ");
        out.println("        if (CheckStr(thisYear, ' ', '')==0 || CheckStr(thisYear, '&nbsp;', '')==0) { ");
        out.println("            alert(' Է ּ'); ");
        out.println("            document.myform.thisYear.focus();");
        out.println("            return false; ");
        out.println("        } ");
        out.println("        var thisMonth = document.myform.thisMonth.value; ");
        out.println("        if (CheckStr(thisMonth, ' ', '')==0 || CheckStr(thisMonth, '&nbsp;', '')==0) { ");
        out.println("            alert(' Է ּ'); ");
        out.println("            document.myform.thisMonth.focus();");
        out.println("            return false; ");
        out.println("        } ");
        out.println("        var thisDate = document.myform.thisDate.value; ");
        out.println("        if (CheckStr(thisDate, ' ', '')==0 || CheckStr(thisDate, '&nbsp;', '')==0) { ");
        out.println("            alert(' Է ּ'); ");
        out.println("            document.myform.thisDate.focus();");
        out.println("            return false; ");
        out.println("        } ");
        out.println("        if(!isNumber(thisYear)){");
        out.println("            alert('ڸ Է ּ'); ");
        out.println("            document.myform.thisYear.focus();");
        out.println("            return true;");
        out.println("        }");
        out.println("        if(!isNumber(thisMonth)){");
        out.println("            alert('ڸ Է ּ'); ");
        out.println("            document.myform.thisMonth.focus();");
        out.println("            return true;");
        out.println("        }");
        out.println("        if(!isNumber(thisDate)){");
        out.println("            alert('ڸ Է ּ'); ");
        out.println("            document.myform.thisDate.focus();");
        out.println("            return true;");
        out.println("        }");
        out.println("        if(thisMonth > 12 || thisMonth < 1){");
        out.println("            alert(' 1 ~ 12 ̳ մϴ.'); ");
        out.println("            document.myform.thisMonth.focus();");
        out.println("            return true;");
        out.println("        }");
        out.println("        if(thisDate > 31 || thisDate < 1){");
        out.println("            alert(' 1 ~ 31 ̳ մϴ.'); ");
        out.println("            document.myform.thisDate.focus();");
        out.println("            return true;");
        out.println("        }");
        out.println("        document.myform.action='"+contextRoot+"/servlet/KCount';");
        out.println("        document.myform.submit();");
        out.println("    }");
        out.println("    function isNumber(ch) {");
        out.println("        var numUnicode = ch.charCodeAt(0);");
        out.println("        if ( 48 <= numUnicode && numUnicode <= 57 ) return true;");
        out.println("        return false;");
        out.println("    }");
        out.println("    function CheckStr(strOriginal, strFind, strChange){ ");
        out.println("        var position, strOri_Length; ");
        out.println("        position = strOriginal.indexOf(strFind);  ");
        out.println("        while (position != -1){ ");
        out.println("            strOriginal = strOriginal.replace(strFind, strChange); ");
        out.println("            position = strOriginal.indexOf(strFind); ");
        out.println("        } ");
        out.println("        strOri_Length = strOriginal.length; ");
        out.println("        return strOri_Length; ");
        out.println("    } ");
        out.println("    function go(s1,s2,s3){");
        out.println("        location.href = '"+contextRoot+"/servlet/KCount?sta=ipNagent&thisYear='+s1+'&thisMonth='+s2+'&thisDate='+s3;");
        out.println("    }");
        out.println("    function moveBlock(str,s1,s2,s3){");
        out.println("        location.href = '"+contextRoot+"/servlet/KCount?sta=ipNagent&thisYear='+s1+'&thisMonth='+s2+'&thisDate='+s3+'&gotoPage='+str;");
        out.println("    }");
        out.println("    //-->");
        out.println("</script>");
        out.println("<tr><td colspan=2 align=center>");
        out.println("   <table width=480 cellpadding=0 cellspacing=0 border=0>");
        out.println("      <TR><TD width=180 valign=top><B>Yearly statistics</b></TD>");
        out.println("      <TD width==300 align=right>");
        out.println("          <a href='"+contextRoot+"/servlet/KCount?sta=ipNagent&thisYear="+thisYear+"&thisMonth="+thisMonth+"&thisDate="+thisDate+"&cmd=ip'><img src='"+contextRoot+"/kcount/images/ip.gif' border=0></a> ");
        out.println("          <a href='"+contextRoot+"/servlet/KCount?sta=ipNagent&thisYear="+thisYear+"&thisMonth="+thisMonth+"&thisDate="+thisDate+"&cmd=ref'><img src='"+contextRoot+"/kcount/images/ref.gif' border=0></a> ");
        out.println("          <a href='"+contextRoot+"/servlet/KCount?sta=ipNagent&thisYear="+thisYear+"&thisMonth="+thisMonth+"&thisDate="+thisDate+"&cmd=brow'><img src='"+contextRoot+"/kcount/images/brow.gif' border=0></a> ");
        out.println("          <a href='"+contextRoot+"/servlet/KCount?sta=ipNagent&thisYear="+thisYear+"&thisMonth="+thisMonth+"&thisDate="+thisDate+"&cmd=os'><img src='"+contextRoot+"/kcount/images/os.gif' border=0></a>");
        out.println("       </TD></TR>");
        out.println("   </TABLE>");
    }
}