package kr.pe.kkaok.mycount.command;

import java.io.PrintWriter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import kr.pe.kkaok.mycount.command.sub.*;
import kr.pe.kkaok.util.ParamUtil;

/**
 * @author kkaok
 * @version  ī v2.4<br>
 * Copyright kkaok, All Rights Reserved.
 */
public class CountYearCommandImpl extends Command
{
    public CountYearCommandImpl(HttpServletRequest req, HttpServletResponse res) throws Exception 
    {
        super(req, res);
    }

    public void exec() throws Exception
    {
        String cmd = ParamUtil.getReqParameter(req.getParameter("cmd"),"year");

        int sDate = SINCE_YEAR*10000+SINCE_MONTH*100+SINCE_DATE;
        int eDate = NOW_YEAR*10000+NOW_MONTH*100+NOW_DATE;

        cPrint.printHeader(out);
        cPrint.printMenu(out,contextRoot);
        printMain(out);
        SubCommand c = null;
        if (cmd.equals("year")){
            c = new YearDataImpl(SINCE_YEAR,NOW_YEAR,out,contextRoot);
            c.exec();
        }else if (cmd.equals("ip")){
            c = new IPStatisticsImpl(sDate,eDate,out,contextRoot); 
            c.exec();
        }else if (cmd.equals("ref")){
            c = new REFStatisticsImpl(sDate,eDate,out,contextRoot);
            c.exec();
        }else if (cmd.equals("brow")){
            c = new BROWStatisticsImpl(sDate,eDate,out,contextRoot);
            c.exec();
        }else if (cmd.equals("os")){
            c = new OSStatisticsImpl(sDate,eDate,out,contextRoot); 
            c.exec();
        }
        cPrint.printBottom(out,contextRoot);
    }
      
    private void printMain(PrintWriter out) throws Exception
    {
        out.println("<tr><td colspan=2 align=center>");
        out.println("   <table width=480 cellpadding=0 cellspacing=0 border=0>");
        out.println("      <TR><TD width=180 valign=top><B>Yearly statistics</b></TD>");
        out.println("      <TD width==300 align=right>");
        out.println("          <a href='"+contextRoot+"/servlet/KCount?sta=year&cmd=ip'><img src='"+contextRoot+"/kcount/images/ip.gif' border=0></a> ");
        out.println("          <a href='"+contextRoot+"/servlet/KCount?sta=year&cmd=ref'><img src='"+contextRoot+"/kcount/images/ref.gif' border=0></a> ");
        out.println("          <a href='"+contextRoot+"/servlet/KCount?sta=year&cmd=brow'><img src='"+contextRoot+"/kcount/images/brow.gif' border=0></a> ");
        out.println("          <a href='"+contextRoot+"/servlet/KCount?sta=year&cmd=os'><img src='"+contextRoot+"/kcount/images/os.gif' border=0></a></TD></TR>");
        out.println("   </TABLE>");
    }
}