package kr.pe.kkaok.mycount.command.sub;

import java.util.List;
import java.io.PrintWriter;
import kr.pe.kkaok.mycount.dao.DataItem;
import kr.pe.kkaok.mycount.dao.PlotData;

/**
 * @author kkaok
 * @version  ī v2.4<br>
 * Copyright kkaok, All Rights Reserved.
 */
public class DayDataImpl extends SubCommand
{
    private int thisYear;
    private int thisMonth;
    private int startYear;
    private int endYear;
    private int startMonth;
    private int endMonth;

    public DayDataImpl(int thisYear,int thisMonth,int startYear,int endYear,
            int startMonth,int endMonth,PrintWriter out, String contextRoot) throws Exception 
    {
        super(out, contextRoot);
        this.thisYear  = thisYear;    
        this.thisMonth = thisMonth;    
        this.startYear = startYear;    
        this.endYear   = endYear;    
        this.startMonth= startMonth;    
        this.endMonth  = endMonth;    
    }

    public void exec() throws Exception
    {
        PlotData data = dao.getDayData(thisYear,thisMonth);

        out.println("<table cellspacing=0 cellpadding=3 border=0>");
        out.println("   <TR height=10><TD colspan=2></TD></TR>");
        out.println("   <tr height=20>");
        out.println("       <td width=200 align=right><b>Total [ "+thisYear+"Ҵ "+thisMonth+" ] : </b></td>");
        out.println("       <td width=200>"+data.total()+" hits </td>");
        out.println("   </TR>");
        out.println("   <tr height=20 >");
        out.println("       <td align=right width=200><b>Max [ "+data.maxLabelStr()+" ] : </b></td>");
        out.println("       <td width=200>"+data.maxValue()+" hits ["+(int)((float)((float)data.maxValue()/(float)data.total())*100)+"%]</td>");
        out.println("   </TR>");
        out.println("   <tr height=20 >");
        out.println("       <td align=right width=200><b>Avg : </b></td>");
        out.println("       <td width=200>"+data.avgValue()+" hits</td>");
        out.println("   </TR>");
        out.println("   <TR height=10><TD colspan=2></td></tr>");
        out.println("</table>");
        out.println("<table width=100% cellspacing=0 cellpadding=1>");
        out.println("   <tr height=20><td colspan=2><b>Day graph</b></td>");
        out.println("   <tr height=20><td colspan=2> ");
        for (int i = endYear; i >= startYear; i--) {
            if(thisYear==i){
                out.println("<font style='color:#FFC000;font-family:ü'>"+i+"Ҵ</font> | ");
            }else{
                if(thisYear > i){
                    out.println("<a href='"+contextRoot+"/servlet/KCount?sta=day&thisYear="+i+"&thisMonth=12'>"+i+"Ҵ</a> | ");
                }else{
                    out.println("<a href='"+contextRoot+"/servlet/KCount?sta=day&thisYear="+i+"&thisMonth=1'>"+i+"Ҵ</a> | ");
                }
            }
        }
        out.println("   </td></TR>");
        out.println("   <tr height=20><td colspan=2>");
        for (int k = startMonth; k <= endMonth; k++) {
            if(thisMonth==k) out.println("<font style='color:#FFC000;font-family:ü'>"+k+"</font> | ");
            else out.println("<a href='"+contextRoot+"/servlet/KCount?sta=day&thisYear="+thisYear+"&thisMonth="+k+"'>"+k+"</a> | ");
        }
        out.println("   </td></TR>");
        out.println("   <TR bgcolor=#dddddd height=1><TD colspan=2></TD></TR>");
        out.println("   <TR height=10><TD colspan=2></TD></TR>");
        DataItem items = null;
        List dataList = (List)data.getDataItems();
        for (int k=0;k<dataList.size();k++){
            items = (DataItem)dataList.get(k);
            out.println("<TR><TD width='15%' align=center>"+items.getLabel()+"</TD>");
            out.println("<TD><img src='"+contextRoot+"/kcount/images/graph.gif' height=10 ");
            out.println("width="+(int)((float)items.getValue()/(float)data.maxValue()*65)+"%");
            out.println(" ><span style='font-size:7pt;'>&nbsp;( ");
            out.println((int)((float)items.getValue()/(float)data.total()*100)+"% <b>");
            out.println(items.getValue()+"</b> hits "); 
            if(items.getValue()== data.maxValue()) 
                out.println("<font color=red>max</font>)</span></TD></TR>"); 
            else 
                out.println(")</span></TD></TR>"); 
        }
    }
}  
