package kr.pe.kkaok.mycount.command.sub;

import java.io.PrintWriter;
import java.util.Calendar;
import kr.pe.kkaok.mycount.pageDivision.MovePageCount;

/**
 * @author kkaok
 * @version  ī v2.4<br>
 * Copyright kkaok, All Rights Reserved.
 */
public class IpnAgentDataImpl extends SubCommand
{
    private int thisYear;
    private int thisMonth;
    private int thisDate;
    private int gotoPage;
    private static final int pageSize = 20;

    public IpnAgentDataImpl(int thisYear,int thisMonth,int thisDate,
            int gotoPage, PrintWriter out, String contextRoot) throws Exception 
    {
        super(out, contextRoot);
        this.thisYear  = thisYear;    
        this.thisMonth = thisMonth;    
        this.thisDate  = thisDate;    
        this.gotoPage  = gotoPage;    
    }

    public void exec() throws Exception
    {
        Calendar c1 = Calendar.getInstance();
        Calendar c2 = Calendar.getInstance();
        Calendar c3 = Calendar.getInstance();
        c1.set(thisYear,thisMonth-1,thisDate);
        int cmakeToday = (c1.get(Calendar.YEAR)*10000)+((c1.get(Calendar.MONTH)+1)*100)+c1.get(Calendar.DATE);
        
        c2.set(thisYear,thisMonth-1,thisDate-1);
        int prevYear    = c2.get(Calendar.YEAR);
        int prevMonth   = c2.get(Calendar.MONTH) + 1;
        int prevNowdate = c2.get(Calendar.DATE);
        
        c3.set(thisYear,thisMonth-1,thisDate+1);
        int nextYear    = c3.get(Calendar.YEAR);
        int nextMonth   = c3.get(Calendar.MONTH) + 1;
        int nextNowdate = c3.get(Calendar.DATE);

        int totalSum = dao.getTotalSum(cmakeToday);

        int totalPage = (int)((totalSum-1)/pageSize)+1;
        if(totalPage == 0) totalPage = 1 ;
        if(gotoPage > totalPage) gotoPage = totalPage;

        out.println("<form name='myform' style='margin:0'>");
        out.println("<table width=480 cellspacing=0 cellpadding=0 border=0>");
        out.println("   <tr><td colspan=3 align=right><b>"+thisYear+"Ҵ "+thisMonth+" "+thisDate+"</b></td></tr>");
        out.println("   <TR><td width=100>Today, <b>"+totalSum+"</b> visited &nbsp;</td>");
        out.println("       <TD align=center>");
        out.println("           Year<input type='text' name='thisYear' size=4> Month ");
        out.println("           <input type='text' name='thisMonth' size=2> Day ");
        out.println("           <input type='text' name='thisDate' size=2> ");
        out.println("           <img src='"+contextRoot+"/kcount/images/go.gif' border=0 style='cursor:hand' onclick='sendit()'></TD>");
        out.println("       <td width=100 align=right>");
        out.println("           <img src='"+contextRoot+"/kcount/images/prev.gif' border=0 style='cursor:hand' onclick='go("+prevYear+","+prevMonth+","+prevNowdate+")'>");
        out.println("           <img src='"+contextRoot+"/kcount/images/next.gif' border=0 style='cursor:hand' onclick='go("+nextYear+","+nextMonth+","+nextNowdate+")'>");
        out.println("       </td>");
        out.println("   </tr>");
        out.println("</TABLE>");
        out.println("<input type='hidden' name='gotoPage'>");
        out.println("<input type='hidden' name='sta' value='ipNagent'>");
        out.println("</form>");
        out.println("<table width=100% cellspacing=0 cellpadding=1 border=0>");
        out.println("   <tr height=10><td colspan=5></td></TR>");
        out.println("   <TR bgcolor=#dddddd height=1><TD colspan=5></TD></TR>");
        out.println("   <TR height=2><TD colspan=5></TD></TR>");
        out.println("   <TR>");
        out.println("       <TD width=40 ALIGN=CENTER>TIME</TD>");
        out.println("       <TD width=90 ALIGN=CENTER>IP</TD>");
        out.println("       <TD width=190 ALIGN=CENTER>REFERER</TD>");
        out.println("       <TD width=50 ALIGN=CENTER>BROWSER</TD>");
        out.println("       <TD width=100 ALIGN=CENTER>OS</TD>");
        out.println("   </TR>");
        out.println("   <TR height=2><TD colspan=5></TD></TR>");
        out.println("   <TR bgcolor=#dddddd height=1><TD colspan=5></TD></TR>");

        out.println(dao.getInfo(cmakeToday,gotoPage,pageSize,totalSum));

        out.println("        <TR height=10><TD colspan=5></TD></TR>");
        out.println("        <TR bgcolor=#dddddd height=1><TD colspan=5></TD></TR>");
        out.println("      </table>");
        out.println("      <table cellpadding=0 cellspacing=0 border=0 width=100% >");
        out.println("        <tr height=25><td align=center>");
        MovePageCount.pageDivision(totalPage,10,gotoPage,thisYear,thisMonth,thisDate,out);
        out.println("        </td></tr>");
    }
}  
