package kr.pe.kkaok.mycount.command.sub;

import java.util.List;
import java.io.PrintWriter;
import kr.pe.kkaok.mycount.dao.PlotData;
import kr.pe.kkaok.mycount.dao.DataItem;

/**
 * @author kkaok
 * @version  ī v2.4<br>
 * Copyright kkaok, All Rights Reserved.
 */
public class YearDataImpl extends SubCommand
{
    private int SINCE_YEAR;
    private int NOW_YEAR;

    public YearDataImpl(int SINCE_YEAR,int NOW_YEAR,
            PrintWriter out, String contextRoot) throws Exception 
    {
        super(out, contextRoot);
        this.SINCE_YEAR = SINCE_YEAR;    
        this.NOW_YEAR   = NOW_YEAR;
    }

    public void exec() throws Exception
    {
        PlotData data = (PlotData)dao.getYearData(SINCE_YEAR,NOW_YEAR);

        out.println("   <table cellspacing=0 cellpadding=3 border=0>");
        out.println("     <TR height=10><TD colspan=2></TD></TR>");
        out.println("     <tr height=20>");
        out.println("       <td width=200 align=right><b>Total : </b></td>");
        out.println("       <td width=200>"+data.total()+" hits</td>");
        out.println("     </TR>");
        out.println("     <tr height=20>");
        out.println("        <td width=200 align=right><b>Max : </b></td>");
        out.println("        <td width=200>"+data.maxValue()+" hits ["+data.maxLabelStr()+"Ҵ]</td>");
        out.println("     </TR>");
        out.println("     <tr height=20>");
        out.println("        <td width=200 align=right><b>Avg : </b></td>");
        out.println("        <td width=200>"+data.avgValue()+" hits</td>");
        out.println("     </TR>");
        out.println("     <TR height=10><TD colspan=2></td></tr></table>");
        out.println("   <table width=100% cellspacing=0 cellpadding=1>");
        out.println("     <tr style='font-weight: bold;' height=20><td colspan=2>Year graph</td></TR>");
        out.println("     <TR height=1 bgcolor=#dddddd><TD colspan=2></TD></TR>");
        out.println("     <TR height=10><TD colspan=2>");
        out.println("     <TR height=1><TD colspan=2></TD></TR>");
        DataItem items = null;
        List dataList = (List)data.getDataItems();
        for (int k=0;k<dataList.size();k++){
            items = (DataItem)dataList.get(k);
            out.println("<TR><TD width=50 align=center>"+items.getLabel()+"Ҵ</TD>");
            out.println("<TD><img src='"+contextRoot+"/kcount/images/graph.gif' height=10 ");
            out.println("width="+(int)(((float)items.getValue()/(float)data.maxValue())*65)+"%");
            out.println(" ><span style='font-size:7pt;'>&nbsp;( ");
            out.println((int)(((float)items.getValue()/(float)data.total())*100)+"% <b>");
            out.println(items.getValue()+"</b> hits "); 
            if(items.getValue()==data.maxValue()) 
                out.println("<font color=red>max</font>)</span></TD></TR>"); 
            else
                out.println(")</span></TD></TR>"); 
        }
    }
}