package kr.pe.kkaok.mycount.dao;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import kr.pe.kkaok.jdbc.DBManager;
import kr.pe.kkaok.util.ParamUtil;

/*
 * Author(s) kkaok
 * Date: 2003.06.26
 * Copyright kkaok,  All Rights Reserved.
 */
public class OraKCountDAOImpl implements KMyCountDAO
{
    private static final String QUERY1 = "insert into kcount(idx,cdate,ctime,dayofweek,ip,referer,browser,os) values(sq_kcount_idx.NEXTVAL,?,?,?,?,?,?,?)";
    private static final String QUERY2 = "select /*+ index_desc(kcount kcount_cdate_indx) */ count(*) today from kcount where cdate = ?";
    private static final String QUERY3 = "select /*+ index_desc(kcount kcount_pk_idx) */ max(idx) totalSum from kcount";
    private static final String QUERY4 = "select /*+ index_desc(kcount kcount_pk_idx) */ idx from kcount where rownum <= 1";
    private static final String QUERY5 = "select /*+ index_desc(kcount kcount_cdate_indx) */ count(idx) todayIdx from kcount where cdate= ?";
    private static final String QUERY6 = "select /*+ index_desc(kcount kcount_cdate_indx) */ count(idx) prevDayIdx from kcount where cdate< ? and cdate >= ?";
    private static final String QUERY7 = "select browser,cnt from (select /*+ index(kcount kcount_cdate_indx) */ browser, count(idx) cnt from kcount where (cdate >=?) and (cdate <=?) group by browser) where rownum <=50 order by cnt desc";
    private static final String QUERY8 = "select os, cnt from (select /*+ index(kcount kcount_cdate_indx) */ os, count(idx) cnt from kcount where (cdate >=?) and (cdate <=?) group by os) where rownum <=50 order by cnt desc";
    private static final String QUERY9 = "select ip, cnt from (select /*+ index(kcount kcount_cdate_indx) */ ip, count(idx) cnt from kcount where (cdate >=?) and (cdate <=?) group by ip) where rownum <=50 order by cnt desc";
    private static final String QUERY10= "select referer, cnt from (select /*+ index(kcount kcount_cdate_indx) */ referer, count(idx) cnt from kcount where (cdate >=?) and (cdate <=?) group by referer) where rownum <=50 order by cnt desc";
    private static final String QUERY11= "select /*+ index_desc(kcount kcount_cdate_indx) */ max(idx) maxIdx from kcount where cdate <?";
    private static final String QUERY12= "select /*+ index_desc(kcount kcount_cdate_indx) */ max(idx) cnt from kcount where (cdate >?) and (cdate <?)";
    private static final String QUERY13= "select /*+ index_desc(kcount kcount_cdate_indx) */ max(idx) cnt from kcount where (cdate=?)";
    private static final String QUERY14= "select /*+ index_desc(kcount kcount_cdate_indx) */ count(idx) cnt,cdate from kcount where (cdate >?) and (cdate <?) Group by cdate";
    private static final String QUERY15= "select /*+ index_desc(kcount kcount_cdate_indx) */ count(idx) cnt from kcount where (cdate = ?)";
    private static final String QUERY16= "select ctime,ip,referer,browser,os from kcount where (cdate = ?) order by idx desc limit ?,?";
    private static final String QUERY17= "select /*+ index(kcount kcount_dayofweek_indx) */ count(idx) cnt,dayofweek from kcount group by dayofweek ";

    /**
     * ī͸ ϴ κ̴.
     * ̺κ ڵ ϴµ   ߻  ִ.<br>
     *  ϺѰ Ѵٸ ̺κ idx ִ밪 ؼ insert Ѿ Ѵ.
     * @param cTable ̺ Ǵ  ִ ̴.
     */
    public void plusNewCount(CountTable cTable) throws Exception
    {
        PreparedStatement pstmt = null;
        Connection conn = null;
        synchronized(this){
            try{
                conn = DBManager.getConnection();
                pstmt = conn.prepareStatement(QUERY1);
                pstmt.setInt(1,cTable.getCdate());
                pstmt.setInt(2,cTable.getCtime());
                pstmt.setInt(3,cTable.getDayofweek());
                pstmt.setString(4,cTable.getIp());
                pstmt.setString(5,cTable.getReferer());
                pstmt.setString(6,cTable.getBrowser());
                pstmt.setString(7,cTable.getOs());
                pstmt.executeUpdate();
            }finally{
                DBManager.close(pstmt,conn);
            }
        }
    }

    /**
     * ó¥ μ  ̰  ð ü ī͸ Ѵ.
     * @param makeToday ó¥
     * @return CountManager
     */
    public CountManager getStatistics(int makeToday) throws Exception
    {
        CountManager cm = new CountManager();
        int today = 0;
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY2);
            pstmt.setInt(1,makeToday);
            rs = pstmt.executeQuery();
            if(rs.next())
                today = rs.getInt("today");
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
           
        int totalSum = 0;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY3);
            rs = pstmt.executeQuery();
            if(rs.next())
                totalSum = rs.getInt("totalSum");
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        cm.setToday(today);
        cm.setTotalSum(totalSum);
        return cm;
    }

    /**
     * ü ϱ
     * @return ü
     */
    public int getTotal() throws Exception
    {
        int returnValue = 0;
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY4);
            rs = pstmt.executeQuery();
            if(rs !=null && rs.next()) 
                returnValue = rs.getInt("idx");
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return returnValue;
    }

    /**
     *  ī ϱ^^<br>̻Ÿ  ߺǴ° ?<br> Ǽ  ...<br>
     * @return  ī
     */
    public int getToday(int makeToday) throws Exception
    {
        int returnValue = 0;
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY5);
            pstmt.setInt(1,makeToday);
            rs = pstmt.executeQuery();
            if(rs !=null && rs.next()) 
                returnValue = rs.getInt("todayIdx");
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return returnValue;
    }
        
    /**
     *  ī ϱ
     * @param makeToday ó¥
     * @param makePrevDay ¥
     * @return  ī
     */
    public int getPrevDay(int makeToday,int makePrevDay) throws Exception
    {
        int returnValue = 0;
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY6);
            pstmt.setInt(1,makeToday);
            pstmt.setInt(2,makePrevDay);
            rs = pstmt.executeQuery();
            if(rs !=null && rs.next()) 
                returnValue = rs.getInt("prevDayIdx");
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return returnValue;
    }

    /**
     *  īͱϱ
     * @param sdate ۳¥
     * @param edate ¥
     * @return PlotData
     */
    public PlotData getBrowser(int sdate,int edate) throws Exception
    {
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        String exceptionvalue = "";
        PlotData data = new PlotData();
        DataItem d = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY7);
            pstmt.setInt(1,sdate);
            pstmt.setInt(2,edate);
            rs = pstmt.executeQuery();
            while(rs.next()){
                exceptionvalue = rs.getString("browser");
                if ((exceptionvalue!=null) && (!exceptionvalue.equals(""))){
                    d = new DataItem(exceptionvalue,rs.getInt("cnt"));         
                    data.addElement(d);
                }
            }
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return data;
    }

    /**
     * OS īͱϱ
     * @param sdate ۳¥
     * @param edate ¥
     * @return PlotData
     */
    public PlotData getOs(int sdate,int edate) throws Exception
    {
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        String exceptionvalue = "";
        PlotData data = new PlotData();
        DataItem d = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY8);
            pstmt.setInt(1,sdate);
            pstmt.setInt(2,edate);
            rs = pstmt.executeQuery();
            while(rs.next()){
                exceptionvalue = rs.getString("os");
                if ((exceptionvalue!=null) && (!exceptionvalue.equals(""))){
                    d = new DataItem(exceptionvalue,rs.getInt("cnt"));         
                    data.addElement(d);
                }
            }
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return data;
    }

    /**
     * Ip īͱϱ
     * @param sdate ۳¥
     * @param edate ¥
     * @return PlotData
     */
    public PlotData getIpData(int sdate,int edate) throws Exception
    {
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        String exceptionvalue = "";
        PlotData data = new PlotData();
        DataItem d = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY9);
            pstmt.setInt(1,sdate);
            pstmt.setInt(2,edate);
            rs = pstmt.executeQuery();
            while(rs.next()){
                exceptionvalue = rs.getString("ip");
                if ((exceptionvalue!=null) && (!exceptionvalue.equals(""))){
                    d = new DataItem(exceptionvalue,rs.getInt("cnt"));
                    data.addElement(d);
                }
            }
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return data;
    }

  
    /**
     * ۷ īͱϱ
     * @param sdate ۳¥
     * @param edate ¥
     * @return PlotData
     */
    public PlotData getRefererData(int sdate,int edate) throws Exception
    {
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        String exceptionvalue = "";
        PlotData data = new PlotData();
        DataItem d = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY10);
            pstmt.setInt(1,sdate);
            pstmt.setInt(2,edate);
            rs = pstmt.executeQuery();
            while(rs.next()){
                exceptionvalue = rs.getString("referer");
                if ((exceptionvalue!=null) && (!exceptionvalue.equals(""))){
                    d = new DataItem(exceptionvalue,rs.getInt("cnt"));
                    data.addElement(d);
                }
            }
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return data;
    }

    
    /**
     *  īͱϱ
     * @param SINCE_YEAR īͼġ 
     * @param NOW_YEAR 翬
     * @return PlotData
     */
    public PlotData getYearData(int SINCE_YEAR,int NOW_YEAR) throws Exception
    {
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        PlotData data = new PlotData();
        DataItem d = null;
        int tmpPrevYearCnt = 0;
        for(int k = SINCE_YEAR;k<=NOW_YEAR;k++){
            try{
                conn = DBManager.getConnection();
                pstmt = conn.prepareStatement(QUERY11);
                pstmt.setInt(1,(k+1)*10000);
                rs = pstmt.executeQuery();
                if(rs.next()) {
                    d = new DataItem(Integer.toString(k),rs.getInt("maxIdx")-tmpPrevYearCnt);         
                    data.addElement(d);
                    tmpPrevYearCnt = rs.getInt("maxIdx");
                }
            }finally{
                DBManager.close(rs,pstmt,conn);
            }
        }
        return data;
    }

    /**
     *  īͱϱ
     * @param thisYear ش翬
     * @param startMonth ۿ,  ġ  5  ִ.
     * @param endMonth ,   6̶   6̵ȴ.
     * @return PlotData
     */
    public PlotData getMonthData(int thisYear,int startMonth,int endMonth) throws Exception
    {
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        PlotData data = new PlotData();
        DataItem d = null;
        int monthCnt        = 0;
        int tmpPrevMonthCnt = 0;
        int prevYearCnt = getPrevYearCnt(thisYear);
        for(int k = startMonth;k<=endMonth;k++){
            try{
                conn = DBManager.getConnection();
                pstmt = conn.prepareStatement(QUERY12);
                pstmt.setInt(1,((thisYear*10000)+((k)*100)));
                pstmt.setInt(2,((thisYear*10000)+((k+1)*100)));
                rs = pstmt.executeQuery();
                if(rs.next()) {
                    if (rs.getInt("cnt") > 0){
                        if(k==startMonth) 
                            monthCnt = rs.getInt("cnt") - prevYearCnt;
                        else 
                            monthCnt = rs.getInt("cnt") - tmpPrevMonthCnt;
                        tmpPrevMonthCnt = rs.getInt("cnt");
                        d = new DataItem(Integer.toString(k),monthCnt);
                        data.addElement(d);
                    }else{
                        d = new DataItem(Integer.toString(k),0);
                        data.addElement(d);
                    }
                }
            }finally{
                DBManager.close(rs,pstmt,conn);
            }
        }
        return data;
    }

    /**
     *  īͱϱ
     * @param thisYear ش翬
     * @return 
     */
    public int getPrevYearCnt(int thisYear) throws Exception
    {
        int returnValueInt = 0;
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY13);
            pstmt.setInt(1,(thisYear-1)*10000+1231);
            rs = pstmt.executeQuery();
            if(rs.next()) 
                returnValueInt = rs.getInt("cnt");
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return returnValueInt;
    }

    /**
     *  īͱϱ
     * @param thisYear ش翬
     * @param thisMonth ش
     * @return PlotData
     */
    public PlotData getDayData(int thisYear,int thisMonth) throws Exception
    {
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        PlotData data = new PlotData();
        DataItem d = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY14);
            pstmt.setInt(1,(thisYear*10000)+(thisMonth*100));
            pstmt.setInt(2,(thisYear*10000)+(thisMonth*100)+99);
            rs = pstmt.executeQuery();
            while(rs.next()){
                d = new DataItem(rs.getString("cdate").substring(6,8),rs.getInt("cnt"));         
                data.addElement(d);
            }  
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return data;
    }

    /**
     * ش糯¥ հ豸ϱ
     * @param cmakeToday ش糯¥ 20030626
     * @return ش糯¥ հ
     */
    public int getTotalSum(int cmakeToday) throws Exception
    {
        int returnValue = 0;
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY15);
            pstmt.setInt(1,cmakeToday);
            rs = pstmt.executeQuery();
            if(rs !=null && rs.next()) 
                returnValue = rs.getInt("cnt");
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return returnValue;
    }

    /**
     * ش ¥ ð뺰   
     * @param cmakeToday ش糯¥
     * @param gotoPage 
     * @param pageSize  ַ ڵ 
     * @param recordCount ش ¥ ü ī
     * @return html.toString();
     */
    public String getInfo(int cmakeToday,int gotoPage,int pageSize,int recordCount) throws Exception
    {
        String ctime = "";
        String referer = "";
        String alterTime = "";
        String linkReferer = "";
        int trimStart = 0;
        int trimEnd = 0;

		int start = pageSize*gotoPage;
		if (start > recordCount) pageSize -= (start-recordCount);
		StringBuffer query = new StringBuffer(); 
		query.append("select ctime,ip,referer,browser,os from (select ");
		query.append("/*+ index_desc(kcount kcount_cdate_indx) */ ctime,ip,referer,browser,os,");
		query.append("rownum as rnum from kcount where ");
		query.append("(cdate = ?) and (rownum <= ?) order by rnum desc) where rownum <= ? order by rnum");
       
        StringBuffer html = new StringBuffer();
        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(query.toString());
            pstmt.setInt(1,cmakeToday);
            pstmt.setInt(2,start);
            pstmt.setInt(3,pageSize);
            rs = pstmt.executeQuery();
            while(rs.next()){
                ctime = ParamUtil.getReqParameter(rs.getString("ctime"),"00");
                referer = ParamUtil.getReqParameter(rs.getString("referer"));
                if(ctime.length() == 3) alterTime = "0"+ctime;
                else if(ctime.length() == 2) alterTime = "00"+ctime;
                else if(ctime.length() == 1) alterTime = "000"+ctime; 
                else alterTime = ctime;
                alterTime = alterTime.substring(0,2)+":"+alterTime.substring(2,4);
                
                linkReferer = referer;
                trimStart = referer.indexOf("http://");
                if(trimStart != -1) referer = referer.substring(trimStart+7);  
                trimEnd = referer.indexOf("/");
                if(trimEnd != -1) referer = "http://"+referer.substring(0,trimEnd);  
                
                html.append("<TR>\n");
                html.append("   <TD>"+alterTime+"</TD>\n");
                html.append("   <TD>"+ParamUtil.getReqParameter(rs.getString("ip"))+"</TD>\n");
                html.append("   <TD><a href='"+linkReferer+"' target=_blank class='ref'>"+referer+"</a></TD>\n");
                html.append("   <TD>"+ParamUtil.getReqParameter(rs.getString("browser"))+"</TD>\n");
                html.append("   <TD style='padding-left:5'>"+ParamUtil.getReqParameter(rs.getString("os"))+"</TD>\n");
                html.append("</TR>\n");
            }  
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return html.toString();
    }

    /**
     * Ϻ ī ϱ
     * @return PlotData
     */
    public PlotData getWeeklyCnt() throws Exception
    {
        String[] weekNameStr = { "", "", "", "", "", "", "" };
        PlotData data = new PlotData();
        DataItem d = null;

        ResultSet rs = null;
        PreparedStatement pstmt = null;
        Connection conn = null;
        try{
            conn = DBManager.getConnection();
            pstmt = conn.prepareStatement(QUERY17);
            rs = pstmt.executeQuery();
            while(rs.next()){
                d = new DataItem(weekNameStr[(rs.getInt("dayofweek")-1)],rs.getInt("cnt"));
                data.addElement(d);
            }  
        }finally{
            DBManager.close(rs,pstmt,conn);
        }
        return data;
    }
}