package kr.pe.kkaok.mycount.handle;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import javax.servlet.http.HttpSessionBindingListener;
import javax.servlet.http.HttpSessionBindingEvent;
import java.util.Calendar;
import kr.pe.kkaok.mycount.dao.KMyCountDAOFactory;
import kr.pe.kkaok.mycount.dao.KMyCountDAO;
import kr.pe.kkaok.mycount.dao.CountTable;
import kr.pe.kkaok.util.ParamUtil;

/**
 * ī͸ ߰Ű 
 * @author kkaok
 * @version  ī v2.4<br>
 * Copyright kkaok, All Rights Reserved.
 */
public class CountPlus
{
    /**
     * CountPlus <br>
     * ī͸ ߰Ѵ.<br> ̶ ī ̺  idx ڵ ϸ ִ밪     ׷ Ǹ  ߻Ѵ.<br>
     *   ̱     ִ. Ϻ ߱Ѵٸ ִ밪 ؼ ϰ  ε .
     * @param Req HttpServletRequest
     * @param res HttpServletResponse
     */
    public CountPlus(HttpServletRequest req, HttpServletResponse res) 
    {
        try{
            HttpSession session = req.getSession();
            if(session.getAttribute("curLogin") == null || session.getAttribute("curLogin").equals(""))
            {
                KMyCountDAO dao = KMyCountDAOFactory.getDAO(); 
                CountTable cTable = new CountTable();
                Calendar now = Calendar.getInstance();
                cTable.setCdate((now.get(Calendar.YEAR)*10000)+((now.get(Calendar.MONTH)+1)*100)+now.get(Calendar.DATE));
                cTable.setCtime((now.get(Calendar.HOUR_OF_DAY)*100)+now.get(Calendar.MINUTE));
                cTable.setDayofweek(now.get(Calendar.DAY_OF_WEEK));
                cTable.setIp(req.getRemoteAddr()); 
                String referer = ParamUtil.getReqParameter(req.getHeader("Referer"));
                if(referer.length() >120) referer = referer.substring(0,120);
                cTable.setReferer(referer);
                String UserAgent = ParamUtil.getReqParameter(req.getHeader("User-Agent"),"etc");
                int trimUAStart = UserAgent.indexOf("MSIE");
                if(trimUAStart != -1) UserAgent = UserAgent.substring(trimUAStart);  
                int trimUAEnd = UserAgent.indexOf(";");
                if(trimUAEnd != -1) UserAgent = UserAgent.substring(0,trimUAEnd);  
                if(UserAgent.length() > 15) UserAgent = UserAgent.substring(0,14);
                cTable.setBrowser(UserAgent);
                String osys = ParamUtil.getReqParameter(req.getHeader("User-Agent"),"etc");
                int trimOsStart = osys.indexOf("Windows");
                if(trimOsStart != -1) osys = osys.substring(trimOsStart);  
                int trimOsEnd = osys.indexOf(")");
                if(trimOsEnd != -1) osys = osys.substring(0,trimOsEnd);  
                int trimOsEndEtc = osys.indexOf(";");
                if(trimOsEndEtc != -1) osys = osys.substring(0,trimOsEndEtc);  
                if(osys.length() > 15) osys = osys.substring(0,14);
                cTable.setOs(osys);
                dao.plusNewCount(cTable);
                session.setMaxInactiveInterval(60*30);
                session.setAttribute("curLogin",new CustomBindingListener());
            }
        }catch(Exception e){
            System.out.println(e.toString());
        }
    }
}

class CustomBindingListener implements HttpSessionBindingListener 
{
    String loginid;
    String sessionid;
    SessionManager sm;
    CustomBindingListener(String loginid){
        this.loginid = loginid;
    }
    
    public CustomBindingListener(){
        loginid = "curLogin";
    }
    /**
     * ǿ  ߰ɶ ߻ϴ ̺Ʈ ޼ҵ
     * @param event HttpSessionBindingEvent
     */
    public void valueBound(HttpSessionBindingEvent event) {
        HttpSession ss = event.getSession();
        sessionid = ss.getId();
        sm = SessionManager.getInstance();
        //Hashtable Ǿ̵ α ̵ մϴ.
        sm.addClient(sessionid,loginid);
    }
    /**
     * ǿ  Ҹɶ ߻ϴ ̺Ʈ ޼ҵ
     * @param event HttpSessionBindingEvent
     */
    public void valueUnbound(HttpSessionBindingEvent event) {
        HttpSession ss = event.getSession();
        sessionid = ss.getId();
        sm = SessionManager.getInstance();
        //Hashtable Ǿ̵ Ű  մϴ.
        sm.removeClient(sessionid);
    }
}